import { FieldInfo } from 'model-util-base'
import { ConditionUtil, ConditionUtilImpl, FieldUtil, TableUtilImpl, IdType, JoinTable, SubTable } from 'model-util'
import { Container, Singleton } from 'typescript-ioc' 
import { CrSendCouponRecordLog } from '../models/index' 
/**
 * @author auto generate
 * @version 1.0
 * @date 2021-05-16 14:39
 */
interface CrSendCouponRecordLogCU extends ConditionUtil<CrSendCouponRecordLogCU>{
    UUID:FieldUtil<CrSendCouponRecordLogCU>;
    CSCR_ID:FieldUtil<CrSendCouponRecordLogCU>;
    SEND_RESULT:FieldUtil<CrSendCouponRecordLogCU>;
    SEND_TIME:FieldUtil<CrSendCouponRecordLogCU>;
    SEND_ERROR_DESC:FieldUtil<CrSendCouponRecordLogCU>;
    CREATE_TIME:FieldUtil<CrSendCouponRecordLogCU>;
}

class CrSendCouponRecordLogCUImpl extends ConditionUtilImpl<CrSendCouponRecordLogCUImpl> implements CrSendCouponRecordLogCU{ 
    newInstance(): CrSendCouponRecordLogCUImpl {
        return new CrSendCouponRecordLogCUImpl();
    } 
    get UUID(): FieldUtil<CrSendCouponRecordLogCU>{  
        return new FieldUtil('uuid','uuid','', this);
    }
    get CSCR_ID(): FieldUtil<CrSendCouponRecordLogCU>{  
        return new FieldUtil('cscr_id','cscrId','', this);
    }
    get SEND_RESULT(): FieldUtil<CrSendCouponRecordLogCU>{  
        return new FieldUtil('send_result','sendResult','', this);
    }
    get SEND_TIME(): FieldUtil<CrSendCouponRecordLogCU>{  
        return new FieldUtil('send_time','sendTime','', this);
    }
    get SEND_ERROR_DESC(): FieldUtil<CrSendCouponRecordLogCU>{  
        return new FieldUtil('send_error_desc','sendErrorDesc','', this);
    }
    get CREATE_TIME(): FieldUtil<CrSendCouponRecordLogCU>{  
        return new FieldUtil('create_time','createTime','', this);
    }
}

@Singleton 
class CrSendCouponRecordLogMU extends TableUtilImpl<CrSendCouponRecordLogCU,CrSendCouponRecordLog>{ 
    tableName  = 'cr_send_coupon_record_log';
    tableFields  = ['uuid','cscr_id','send_result','send_time','send_error_desc','create_time'];
    modelFields  = ['uuid','cscrId','sendResult','sendTime','sendErrorDesc','createTime'];
    modelIdFields  = ['uuid'];
    tableIdFields  = ['uuid'];
    idType = IdType.CUSTOM;
    joinTables = [];
    subTables = [];

    createConditionUtil(): CrSendCouponRecordLogCU {
        return new CrSendCouponRecordLogCUImpl();
    }   

    static get UUID(): FieldUtil<CrSendCouponRecordLogCU>{ 
        return new FieldUtil('uuid','uuid','', new CrSendCouponRecordLogCUImpl());
    }
    static get CSCR_ID(): FieldUtil<CrSendCouponRecordLogCU>{ 
        return new FieldUtil('cscr_id','cscrId','', new CrSendCouponRecordLogCUImpl());
    }
    static get SEND_RESULT(): FieldUtil<CrSendCouponRecordLogCU>{ 
        return new FieldUtil('send_result','sendResult','', new CrSendCouponRecordLogCUImpl());
    }
    static get SEND_TIME(): FieldUtil<CrSendCouponRecordLogCU>{ 
        return new FieldUtil('send_time','sendTime','', new CrSendCouponRecordLogCUImpl());
    }
    static get SEND_ERROR_DESC(): FieldUtil<CrSendCouponRecordLogCU>{ 
        return new FieldUtil('send_error_desc','sendErrorDesc','', new CrSendCouponRecordLogCUImpl());
    }
    static get CREATE_TIME(): FieldUtil<CrSendCouponRecordLogCU>{ 
        return new FieldUtil('create_time','createTime','', new CrSendCouponRecordLogCUImpl());
    }

    get UUID(): FieldUtil<CrSendCouponRecordLogCU>{ 
        return CrSendCouponRecordLogMU.UUID;
    }
    get CSCR_ID(): FieldUtil<CrSendCouponRecordLogCU>{ 
        return CrSendCouponRecordLogMU.CSCR_ID;
    }
    get SEND_RESULT(): FieldUtil<CrSendCouponRecordLogCU>{ 
        return CrSendCouponRecordLogMU.SEND_RESULT;
    }
    get SEND_TIME(): FieldUtil<CrSendCouponRecordLogCU>{ 
        return CrSendCouponRecordLogMU.SEND_TIME;
    }
    get SEND_ERROR_DESC(): FieldUtil<CrSendCouponRecordLogCU>{ 
        return CrSendCouponRecordLogMU.SEND_ERROR_DESC;
    }
    get CREATE_TIME(): FieldUtil<CrSendCouponRecordLogCU>{ 
        return CrSendCouponRecordLogMU.CREATE_TIME;
    }
}
export {CrSendCouponRecordLogMU, CrSendCouponRecordLogCU}
